/**
 * 
 */
package org.ajax4jsf.gwt.client.ui;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.ui.HasText;
import com.google.gwt.user.client.ui.Widget;

/**
 * Create widget associated with hidden html input element.
 * @author shura
 *
 */
public class InputHidden extends InputWidget implements HasText {

	/**
	 * 
	 */
	public InputHidden() {
		super();
		Element hidden = DOM.createElement("input");
		setInputType(hidden,"hidden");
		setElement(hidden);
	}

	/**
	 * Create named hidden input field.
	 * @param name
	 */
	public InputHidden(String name){
		this();
		setName(name);
//		DOM.setAttribute(getElement(),"id",name);
	}

	/* (non-Javadoc)
	 * @see com.google.gwt.user.client.ui.HasText#setText(java.lang.String)
	 */
	  public String getText() {
		    return DOM.getAttribute(getElement(), "value");
		  }

	  public void setText(String text) {
		    DOM.setAttribute(getElement(), "value", text);
		  }

	  public String getName() {
			    return DOM.getAttribute(getElement(), "name");
			  }

	  public void setName(String name) {
			    setInputName(getElement(),  name);
			  }
}
