/**
 * 
 */
package org.ajax4jsf.gwt.client.ui;

import com.google.gwt.user.client.DOM;
import com.google.gwt.user.client.Element;
import com.google.gwt.user.client.ui.Widget;

/**
 * Class created hidden html submit button for JSF form submission.
 * @author shura
 *
 */
public class JSFHiddenSubmit extends InputWidget {
	
	private String _id;

	/**
	 * 
	 */
	public JSFHiddenSubmit(String id) {
		super();
		_id = id;
		Element button = DOM.createButton();
		setInputName(button, id);
		setInputType(button,"submit");
		setElement(button);
		setSize("0","0");
		setVisible(false);
	}

	public void submit(String data) throws Exception {
		Element button = getElement();
		if(!isAttached()){
			Element componentElement = DOM.getElementById(_id);
			if(null == componentElement){
				throw new Exception("submit element must be attached to document");
			}
			DOM.appendChild(componentElement,button);
		}
		DOM.setAttribute(button,"value",data);
		click(button);
	}
	
    static native void click(Element button) /*-{
	    button.click();
	  }-*/;

}
