/**
 * 
 */
package org.ajax4jsf.gwt.jsf;

import java.util.Map;

import javax.faces.FacesException;
import javax.faces.context.FacesContext;

import org.ajax4jsf.gwt.client.GwtFacesEvent;
import org.ajax4jsf.gwt.client.GwtFacesResult;

/**
 * @author shura
 * 
 */
public interface GwtComponent {

	/**
	 * @return name of GWT module for component
	 */
	public String getModuleName();
	
	/**
	 * Get name of widget in module.
	 * @return widget name for this component ( or null if not important, in case of only one widget in module )
	 */
	public String getWidgetName();

	/**
	 * For base renderer, create Map<String,String> widget parameters.
	 * This pagameters can be get by {@link org.ajax4jsf.gwt.client.ComponentEntryPoint#getWidgetParams(String )}
	 * For more complex cases, developer must create own renderer.
	 * @return
	 */
	public Map getWidgetParameters();

}
