/**
 * 
 */
package org.ajax4jsf.gwt.jsf;

import javax.faces.component.UIComponent;
import javax.faces.event.FacesEvent;
import javax.faces.event.FacesListener;

import org.ajax4jsf.gwt.client.GwtFacesEvent;
import org.ajax4jsf.gwt.client.GwtFacesResult;

/**
 * @author shura
 *
 */
public abstract class GwtEvent extends FacesEvent {
	
//	private GwtFacesEvent gwtEventData;
	
	/**
	 * @param source
	 */
	public GwtEvent(UIComponent source) {
		super(source);
	}

	/* (non-Javadoc)
	 * @see javax.faces.event.FacesEvent#isAppropriateListener(javax.faces.event.FacesListener)
	 */
	public boolean isAppropriateListener(FacesListener listener) {
		if (listener instanceof GwtListener) {
			GwtListener gwtListener = (GwtListener) listener;
			return gwtListener.isAcceptEvent(getGwtEventData());
		}
		return false;
	}

	/* (non-Javadoc)
	 * @see javax.faces.event.FacesEvent#processListener(javax.faces.event.FacesListener)
	 */
	public void processListener(FacesListener listener) {
		GwtListener gwtListener = (GwtListener) listener;
		setCallbackParameter(gwtListener.processEvent(this.getGwtEventData()));
	}

	/**
	 * @return Returns the callbackParameter.
	 */
	public abstract GwtFacesResult getCallbackParameter();

	/**
	 * @param callbackParameter The callbackParameter to set.
	 */
	public abstract void setCallbackParameter(GwtFacesResult callbackParam);

	/**
	 * @return Returns the gwtEventData.
	 */
	public abstract GwtFacesEvent getGwtEventData();

}
