/**
 * 
 */
package org.ajax4jsf.gwt.jsf;

import java.io.Serializable;

import javax.el.ELContext;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHolder;
import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;

import org.ajax4jsf.gwt.client.GwtFacesEvent;
import org.ajax4jsf.gwt.client.GwtFacesResult;

/**
 * @author shura
 *
 */
public class GwtListenerMethodHelper implements GwtListener,StateHolder {
	
	private MethodExpression _method;
	
	
	private Class _eventType ;
	
	private boolean _transient = false;

	
	/**
	 * 
	 */
	public GwtListenerMethodHelper() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param method
	 * @param listenerType 
	 */
	public GwtListenerMethodHelper(MethodExpression method, Class listenerType) {
		super();
		if (null == method) {
			throw new IllegalArgumentException("Method expression for GwtListener helper must be not null");
		}
		_method = method;
		_eventType = listenerType;
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.gwt.jsf.GwtListener#isAcceptEvent(org.ajax4jsf.gwt.client.GwtFacesEvent)
	 */
	public boolean isAcceptEvent(GwtFacesEvent event) {
			if (null != _eventType) {
				return _eventType.isInstance(event);
			} else {
				return true;
			}
	}

	/* (non-Javadoc)
	 * @see org.ajax4jsf.gwt.jsf.GwtListener#processEvent(org.ajax4jsf.gwt.jsf.GwtEvent)
	 */
	public GwtFacesResult processEvent(GwtFacesEvent event) {
		ELContext context = FacesContext.getCurrentInstance().getELContext();
		return (GwtFacesResult) _method.invoke(context,new Object[] { event });
	}

	/* (non-Javadoc)
	 * @see javax.faces.component.StateHolder#restoreState(javax.faces.context.FacesContext, java.lang.Object)
	 */
	public void restoreState(FacesContext context, Object state) {
		State helperState = (State) state;
		_method = (MethodExpression) UIComponentBase.restoreAttachedState(context,helperState.method);
		_eventType = helperState.eventType;
	}

	/* (non-Javadoc)
	 * @see javax.faces.component.StateHolder#saveState(javax.faces.context.FacesContext)
	 */
	public Object saveState(FacesContext context) {
		State helperState = new State();
		helperState.method = UIComponentBase.saveAttachedState(context,_method);
		helperState.eventType = this._eventType;
		return helperState;
	}

	/**
	 * @return Returns the transient.
	 */
	public boolean isTransient() {
		return _transient;
	}

	/**
	 * @param transient1 The transient to set.
	 */
	public void setTransient(boolean transient1) {
		_transient = transient1;
	}
	
	/**
	 * @author shura
	 *
	 */
	private static class State implements Serializable {
		
		private Object method;
		
		
		private Class  eventType ;

	}

	/**
	 * @param eventType The eventType to set.
	 */
	public void setEventType(Class eventType) {
		_eventType = eventType;
	}

}
