package org.ajax4jsf.gwt.jsf;


/**
 * Interface for all components, need to process RPC events from client part.
 * @author shura
 *
 */
public interface GwtSource {
	/**
     * same as for ActionSource, but for GwtListener
     * 
     * @see javax.faces.component.ActionSource#addActionListener(javax.faces.event.ActionListener)
     */
    public void addGwtListener(GwtListener listener);

    /**
     * same as for ActionSource, but for GwtListener
     * 
     * @see javax.faces.component.ActionSource#getActionListeners()
     */
    public GwtListener[] getGwtListeners();

    /**
     *  same as for ActionSource, but for GwtListener
     * @see javax.faces.component.ActionSource#removeActionListener(javax.faces.event.ActionListener)
     */
    public void removeGwtListener(GwtListener listener);

    

}
